﻿using System;
using System.Windows.Forms;

using System.Runtime.InteropServices; // Needed for DllImport
using System.Diagnostics; // Used for Debug.WriteLine


namespace CSharpEnvironment
{
    public partial class Form1 : Form
    {
        [DllImport("NativeEnvironment.dll", EntryPoint = "DoSomethingInNativeC", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Auto)]
        public static extern UInt32 DoSomethingInNativeC(UInt32 FooValue);

        [DllImport("NativeEnvironment.dll", EntryPoint = "DoSomethingInCpp", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Auto)]
        public static extern UInt32 DoSomethingInCpp(UInt32 FooValue);

        [DllImport("NativeEnvironment.dll", EntryPoint = "CallCSharpViaNative", CallingConvention = CallingConvention.Cdecl, CharSet = CharSet.Auto)]
        public static extern UInt32 CallCSharpViaNative(UInt32 FooValue);

        public Form1()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, EventArgs e)
        {
            UInt32 MyFooValue = 20;
            UInt32 MyReturnValue;
            MyReturnValue = DoSomethingInNativeC(MyFooValue);
            Debug.WriteLine("Return value of DoSomethingInNativeC = " + MyReturnValue.ToString());
        }

        private void button2_Click(object sender, EventArgs e)
        {
            UInt32 MyFooValue = 11;
            UInt32 MyReturnValue;
            MyReturnValue = DoSomethingInCpp(MyFooValue);
            Debug.WriteLine("Return value of DoSomethingInCpp = " + MyReturnValue.ToString());
        }

        private void button3_Click(object sender, EventArgs e)
        {
            UInt32 MyFooValue = 30;
            UInt32 MyReturnValue;
            MyReturnValue = CallCSharpViaNative(MyFooValue);
            Debug.WriteLine("Return value of DoSomethingInNativeC = " + MyReturnValue.ToString());
        }



    }

    public class CSharpClass
    {
        public static void DoSomethingInCSharp(UInt32 CSharpOutValue)
        {
            Debug.WriteLine("CSharpOutValue = " + CSharpOutValue.ToString());
        }
    }

}
