// Usings:
using namespace CSharpEnvironment; // Needed to call methodes in CSharpEnvironment:

// Includes:
#include "Native.h"
#include "Wrapper.h"

// This methode is only called from CSharpEnvironment, 
// it does not touch the Native C Code.
unsigned int DoSomethingInCpp(unsigned int FooValue)
{
    return FooValue + 1;
}

// This methode is called from CSharpEnvironment and call a methode in Native C.
// This is the typically wrapper C#->Native functionality.
unsigned int CallCSharpViaNative(unsigned int FooValue)
{    
    unsigned int ReturnValue;
    ReturnValue = DoSomeOthersInNativeC(FooValue + 1);
    return ReturnValue + 1;
}

// This methode is called from Native C-Code and call a methode in CSharp Environment.
// This is the typically wrapper Native->C# functionality.
void CallManagedCode(unsigned int FooValue)
{
    CSharpClass::DoSomethingInCSharp(FooValue + 2);
}
